﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx.Helpers;
using System.Windows.Forms;


namespace BarryDurex
{
    class CKSSettings : Settings
    {
        public static CKSSettings Instance = new CKSSettings();

        public CKSSettings()
            : base(Application.StartupPath + "\\Settings\\CritterKillSquad\\Settings.xml")
        {
            Load();
        }

        ~CKSSettings()
        {
            Save();
        }

        [Setting(Explanation = "--"), DefaultValue(false)]
        public bool ProfileRnd { get; set; }

        [Setting(Explanation = "--"), DefaultValue(true)]
        public bool ProfileCir { get; set; }

        [Setting(Explanation = "--"), DefaultValue(false)]
        public bool ProfileBou { get; set; }
    }
}
